function affiche_flot( I1, I2, vx, vy, sparse, scale, nfig )

if nargin < 7
    nfig = 1;
end
if nargin < 6
    scale = 1;
end
if nargin < 5
    sparse = 5;
end

[dy, dx] = size(vx);

figure(nfig); hold on;
imshow(127+.5*I1);

mvx = mean2(vx);
mvy = mean2(vy);

vx = (vx - mvx)*scale;
vy = (vy - mvy)*scale;

[XX, YY] = meshgrid( 1:sparse:dy, 1:sparse:dx);
hold on;
scatter(YY(:),XX(:),'k.');

for i = 1:sparse:dy
    for jj = 1:sparse:dx
        hue = mod(angle(vx(i,jj)+1i*vy(i,jj)) / (2*pi),1);
        valp = .3*cos(2*pi*(hue+0.25));
        line( [jj,jj+vx(i,jj)], [i,i+vy(i,jj)], 'color', hsv2rgb(hue,1,.7+valp),...
                                                'LineWidth', 3);
%        scatter(j,i);
    end
end


% 
% figure(2); hold on;
% imshow(127+.5*I2);
% 
% [XX, YY] = meshgrid( 1:sparse:dy + mvy, 1:sparse:dx + mvx);
% hold on;
% scatter(YY(:),XX(:),'b.');
% 
% for i = 1:sparse:dy
%     for jj = 1:sparse:dx
%         hue = mod(angle(vx(i,jj)+1i*vy(i,jj)) / (2*pi),1);
%         line( [mvx+jj,mvx+jj+vx(i,jj)], [mvy+i,mvy+i+vy(i,jj)], 'color', hsv2rgb(hue,1,1)  );
% %        scatter(j,i);
%     end
% end
% 



end