function [cnn_arr, grid_x, grid_y, imf] = dense_cnn2(I, d)

I = double(I);

% net = load('imagenet-vgg-f');
net = load('imagenet-vgg-f_d');
net = net.net;
d = min(d,numel(net.layers));


% parameters

imf = single(I);
imf = imresize(imf, net.normalization.imageSize(1:2));
im_ = imf - net.normalization.averageImage;
res = vl_simplenn(net, im_); % Need the vl_feat library for the CNN
cnn_arr = res(1,d+1).x;

% Outputs:
grid_x = 1:size( im_, 2 );
grid_y = 1:size( im_, 1 );

for i=1:d
  l = net.layers{i};
  
  switch l.type
    case 'conv'
        filtsize = size(l.filters);
        fx = floor( filtsize(2) / 2 );
        fy = floor( filtsize(1) / 2 );
        sx = l.stride(1);
        sy = l.stride(2);
        dumx = ( 1 - l.pad(3) + fx ) : sx : ( length(grid_x) + l.pad(4) - fx );
        dumy = ( 1 - l.pad(1) + fy ) : sy : ( length(grid_y) + l.pad(2) - fy );
        grid_x = grid_x(dumx);
        grid_y = grid_y(dumy);
    case 'pool'
        sx = l.stride(1);
        sy = l.stride(2);
        dumx = ( 1 - l.pad(3) ) : sx : ( length(grid_x) );%+ l.pad(4) );
        dumy = ( 1 - l.pad(1) ) : sy : ( length(grid_y) );%+ l.pad(2) );
        grid_x = grid_x(dumx);
        grid_y = grid_y(dumy);
    case 'normalize'
    case 'softmax'
%    case 'loss'
%    case 'softmaxloss'
    case 'relu'
%    case 'noffset'
%    case 'dropout'
%    case 'custom'
    otherwise
      error('Unknown layer type %s', l.type) ;
  end
  
end

%[grid_x,grid_y] = meshgrid();


