
clear all
close all
warning off

IM = im2double(rgb2gray(imread('data/occlusion/exp_filter/2_1.jpg')));
figure;imshow(IM,[]);



% load IM



[r c] = size(IM);
data = IM(:);
[center,U,obj_fcn] = kmeans(data,4); % Fuzzy C-means classification with 4 classes
         

% Finding the pixels for each class

maxU = max(U);
index1 = find(U(1,:) == maxU);
index2 = find(U(2,:) == maxU);
index3 = find(U(3,:) == maxU);
index4 = find(U(4,:) == maxU);



% Assigning pixel to each class by giving them a specific value

fcmImage(1:length(data))=0;       
fcmImage(index1)= 1;
fcmImage(index2)= 0.66;
fcmImage(index3)= 0.33;
fcmImage(index4)= 0.0;





% Reshapeing the array to a image

imagNew = reshape(fcmImage,r,c);
figure;imshow(imagNew,[]);



gradmag = imagNew;
g = gradmag - min(gradmag(:));
g = g / max(g(:));



th = graythresh(g); %# Otsu's method.
a = imhmax(g,th/2); %# Conservatively remove local maxima.
th = graythresh(a);
b = a > th/4; %# Conservative global threshold.
c = imclose(b,ones(8)); %# Try to close contours.
d = imfill(c,'holes'); %# Not a bad segmentation by itself.

%# Use the rough segmentation to define markers.

g2 = imimposemin(g, ~ imdilate( bwperim(a), ones(4) ));
L = watershed(g2);
Lrgb = label2rgb(L);
figure;imshow(Lrgb,[]);

% 
% rgb = imread('data/occlusion/exp_filter/2_1.jpg');
% I = rgb2gray(rgb);
% %I = double(I);
% %I = imfilter(I,fspecial('unsharp', 0.5));
% %I = medfilt2(I, [3,3]);
% I = uint8(imfilter(im2bw(I,0.5),fspecial('sobel'))) + I;
% imshow(I)
% 
% hy = fspecial('sobel');
% hx = hy';
% Iy = imfilter(double(I), hy, 'replicate');
% Ix = imfilter(double(I), hx, 'replicate');
% gradmag = sqrt(Ix.^2 + Iy.^2);
% figure
% imshow(gradmag,[]), title('Gradient magnitude (gradmag)')
% 
% 
% se = strel('disk', 4);
% Io = imopen(I, se);
% 
% Ie = imerode(I, se);
% Iobr = imreconstruct(Ie, I);
% 
% 
% Ioc = imclose(Io, se);
% 
% Iobrd = imdilate(Iobr, se);
% Iobrcbr = imreconstruct(imcomplement(Iobrd), imcomplement(Iobr));
% Iobrcbr = imcomplement(Iobrcbr);
% 
% fgm = imregionalmax(Iobrcbr);
% 
% se2 = strel(ones(4,4));
% fgm2 = imclose(fgm, se2);
% fgm3 = imerode(fgm2, se2);
% % 
% fgm4 = bwareaopen(fgm3, 5);
% 
% 
% bw = im2bw(Iobrcbr, graythresh(Iobrcbr));
% 
% D = bwdist(bw);
% DL = watershed(D);
% bgm = DL == 0;
% 
% gradmag2 = imimposemin(gradmag, bgm | fgm4);
% L = watershed(gradmag2);
% 
% Lrgb = label2rgb(L, 'jet', 'w', 'shuffle');
% 
% figure
% imshow(I)
% hold on
% himage = imshow(Lrgb);
% set(himage, 'AlphaData', 0.3);
% hold off
% title('Lrgb superimposed transparently on original image')
% 
