function [labels, peaks] = meanshift_opt(data, r, c)
%% Parametre
r_egal = r/2;
aff = 1000;

bb = 1;  % barre de progression

%% initialisation
n = size(data,2);
K = 0;
labels = zeros(n,1);
peaks = [];

%%
if bb; fprintf('%10d/%10d', 1, n); end;
for i = 1:n
    if mod(i,aff)==0
        if bb; fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%10d/%10d', i, n); end;
    end
    if labels(i)==0    
        % calcul du 'peak' qu'engendre le point i
        [peak_i, cpts_i] = findpeak_opt(data, i, r, c);

        % calcul du 'peak' le plus proche de peak_i
        if K==0
            d_min_carre = 0;
            d_min_label = 0;
        else
            [d_min_carre d_min_label] = min(ml_sqrDist(peak_i, peaks));
        end
        
        if((d_min_carre < r_egal^2) && K>0)
            % peak_i correpond deja a un 'peak' precedent
            labels = labels + d_min_label*((labels==0).*cpts_i);
        else
            % on a un nouveau 'peak'
            K = K + 1; 
            peaks = [peaks peak_i];  %#ok<AGROW>

       % on attribue le label K a tous les points proches de la trajectoire
            labels = labels + K*((labels==0).*cpts_i);
            
            % on attribue le label K a tous les points autour du 'peak'.
            nouveau_points = (ml_sqrDist(peak_i, data) < r^2)';
            labels = labels + K*((labels==0).*nouveau_points);
        end
    end
end
            if bb; fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b'); end;
        
        
     

end
